; ==================================================================================================
; Title:   WndFadeOut.asm
; Author:  G. Friedrich / J. Trudgen / K. Usanov
; Version: 1.0.1
; Notes:   Version 1.0.0, January 2005
;            - First release.
;          Version 1.0.1, March 2006
;            - Better Fade Out effect. dSleep verification removed.
; ==================================================================================================


%include @Environ(OA32_PATH)\\Code\\ObjMem32\\ObjMem32.cop

% include &IncPath&Windows.inc
% include &IncPath&User32.inc
% include &IncPath&Kernel32.inc
% include &MacPath&System.inc
% include &MacPath&Memory.inc
% include &MacPath&Strings.inc

externdef szUser32:byte
externdef szSLWA:byte

TypeSLWA typedef proto :Handle, :Pointer, :dword, :dword

WS_EX_LAYERED   equ   80000h
LMA_ALPHA       equ   2
LMA_COLORKEY    equ   1

.code

WndFadeOut proc uses ebx edi, hWnd:Handle, dStart:dword, dStop:dword, dStep:dword, dSleep:dword
    local VerInfo:OSVERSIONINFO

    invoke GetWindowLongA, hWnd, GWL_EXSTYLE
    .ifBitSet eax, WS_EX_LAYERED
      ;Fade out algo for 2000 & XP only
      mov VerInfo.dwOSVersionInfoSize, sizeof OSVERSIONINFO
      invoke GetVersionEx, addr VerInfo
      .if VerInfo.dwMajorVersion >= 5                         ;Win2000 or XP ?
        invoke GetModuleHandleA, offset szUser32              ;Load function dynamically to avoid
        mov edi, $invoke(GetProcAddress, eax, offset szSLWA)  ;problems with Win9x OS.
        mov eax, dStop
        .if eax < dStart
          mov eax, dStep
          .if eax
            mov ebx, dStart
            .repeat
              invoke TypeSLWA ptr edi, hWnd, NULL, ebx, LMA_ALPHA
              invoke UpdateWindow, hWnd
              invoke Sleep, dSleep                          ;Wait a little bit
              sub ebx, dStep
            .until sdword ptr ebx <= dStop
            invoke TypeSLWA ptr edi, hWnd, NULL, dStop, LMA_ALPHA
          .endif
        .endif
      .endif
    .endif
    ret
WndFadeOut endp

end
